package com.dsic.gj_erp.controller.jhgk;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmQfxq;
import com.dsic.gj_erp.bean.jhgk.DmYdjhLj;
import com.dsic.gj_erp.bean.pgd.DmPpxxb;
import com.dsic.gj_erp.mapper.pgd.DmPpxxbMapper;
import com.dsic.gj_erp.service.jhgk.DmQfxqService;
import com.dsic.gj_erp.service.pgd.DmPpxxbService;
import lombok.AllArgsConstructor;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@RestController
@RequestMapping("ypp")
@AllArgsConstructor
public class YppController {

    private final DmQfxqService qfxqService;
    private final DmPpxxbService ppxxbService;

    private final DmPpxxbMapper ppxxbMapper;

    @PostMapping("getQfxq")
    public ResultBean<?> getQfxq(@RequestBody DmQfxq qfxq){
        String existsSql="select dc_ch,dc_pl,dc_fd from dm_ppxxb ";
        StringBuilder builder=new StringBuilder(existsSql);
        builder.append("where 1=1");
        if (StrUtil.isNotEmpty(qfxq.getDcCh())){
            builder.append(" and dc_ch='").append(qfxq.getDcCh()).append("'");
        }

        builder.append(" and dm_qfxq.dc_ch=").append("dm_ppxxb.dc_ch");
        builder.append(" and dm_qfxq.dc_pl=").append("dm_ppxxb.dc_pl");
        builder.append(" and dm_qfxq.dc_fd=").append("dm_ppxxb.dc_fd");
        if (StrUtil.isNotEmpty(qfxq.getDcPl())){
            builder.append(" and dc_pl=").append("'").append(qfxq.getDcPl()).append("'");
        }
        if (StrUtil.isNotEmpty(qfxq.getDcFd())){
            builder.append(" and dc_fd=").append("'").append(qfxq.getDcFd()).append("'");
        }

        builder.append(" group by dc_ch,dc_pl,dc_fd");
        List<DmQfxq> list = qfxqService.list(Wrappers.<DmQfxq>lambdaQuery()
                .eq(StrUtil.isNotEmpty(qfxq.getDcCh()),DmQfxq::getDcCh, qfxq.getDcCh())
                .eq(StrUtil.isNotEmpty(qfxq.getDcPl()),DmQfxq::getDcPl, qfxq.getDcPl())
                .eq(StrUtil.isNotEmpty(qfxq.getDcFd()),DmQfxq::getDcFd, qfxq.getDcFd())
                .eq(StrUtil.isNotEmpty(qfxq.getZt()),DmQfxq::getZt,qfxq.getZt())
                .notExists(builder.toString())
        );
        return new ResultBean<>(list);
    }

    @PostMapping("getLjxx")
    public ResultBean<?> getLjxx(@RequestBody Map<String,Object> map){
        List<DmPpxxb> dmYdjhLj = ppxxbMapper.getDmWlqd(map);
        return new ResultBean<>(dmYdjhLj);
    }

    @PostMapping("getPpxx")
    public ResultBean<?> getPpxx(@RequestBody Map<String,Object> map){
        List<DmPpxxb> dmPpxxb = ppxxbMapper.getDmPpxxb(map);
        return new ResultBean<>(dmPpxxb);
    }

    @PostMapping("getList")
    public ResultBean<?> getList(@RequestBody DmPpxxb dmPpxxb){
        List<DmPpxxb> list = ppxxbService.list(Wrappers.<DmPpxxb>lambdaQuery()
                .eq(DmPpxxb::getDcCh, dmPpxxb.getDcCh())
                .eq(StrUtil.isNotEmpty(dmPpxxb.getDwh()), DmPpxxb::getDwh, dmPpxxb.getDwh())
                .eq(StrUtil.isNotEmpty(dmPpxxb.getQy()), DmPpxxb::getQy, dmPpxxb.getQy())
                .eq(StrUtil.isNotEmpty(dmPpxxb.getDcPl()), DmPpxxb::getDcPl, dmPpxxb.getDcPl())
                .eq(StrUtil.isNotEmpty(dmPpxxb.getDcFd()), DmPpxxb::getDcFd, dmPpxxb.getDcFd())
        );

        return new ResultBean<>(list);
    }

    @PostMapping("checkBfwz")
    public ResultBean<?> checkBfwz(@RequestBody List<DmPpxxb> list){

        return new ResultBean<>();
    }

    @PostMapping("qtjc")
    public ResultBean<?> qtjc(@RequestBody List<DmQfxq> list){
        list.forEach(item->{
            Map map = BeanUtil.beanToMap(item);
            List<DmYdjhLj> dmYdjhLj = ppxxbMapper.getDmYdjhLj(map);
            List<DmPpxxb> dmPpxxb = ppxxbMapper.getDmPpxxb(map);

            if (dmPpxxb.size()==0){
                throw new RuntimeException(item.getDcFd()+"分段未预配盘");
            }

            dmYdjhLj.forEach(_item->{
                //todo 校验完工,缺少完工条件,无法校验
            });

            List<DmPpxxb> collect = dmPpxxb.stream().map(_item -> {
                DmPpxxb ppxxb = new DmPpxxb();
                ppxxb.setFxwph(_item.getFxwph());
                ppxxb.setXwh(_item.getXwh());
                ppxxb.setZt("01");
                return ppxxb;
            }).collect(Collectors.toList());
            ppxxbService.updateBatchByMultiId(collect);
        });
        return new ResultBean<>();
    }

    @PostMapping("zx")
    @Transactional(rollbackFor = Exception.class)
    public ResultBean<?> zx(@RequestBody List<DmQfxq> list){
        List<DmPpxxb> printData=new ArrayList<>();
        list.forEach(item->{
            Map map = BeanUtil.beanToMap(item);
            List<DmPpxxb> dmPpxxb = ppxxbMapper.getDmPpxxb(map);
            List<DmPpxxb> collect = dmPpxxb.stream().map(_item -> {
                DmPpxxb dmPpxxb1 = new DmPpxxb();
                dmPpxxb1.setFxwph(_item.getFxwph());
                dmPpxxb1.setXwh(_item.getXwh());
                dmPpxxb1.setZt("04");
                return dmPpxxb1;
            }).collect(Collectors.toList());
            ppxxbService.updateBatchByMultiId(collect);
            printData.addAll(dmPpxxb);
        });
        return new ResultBean<>(printData);
    }

    @PostMapping("qr")
    @Transactional(rollbackFor = Exception.class)
    public ResultBean<?> qr(@RequestBody List<DmQfxq> list){
        list.forEach(item->{
            Map map = BeanUtil.beanToMap(item);
            List<DmPpxxb> dmPpxxb = ppxxbMapper.getDmPpxxb(map);
            List<DmPpxxb> collect = dmPpxxb.stream().map(_item -> {
                DmPpxxb dmPpxxb1 = new DmPpxxb();
                dmPpxxb1.setFxwph(_item.getFxwph());
                dmPpxxb1.setXwh(_item.getXwh());
                dmPpxxb1.setZt("05");
                return dmPpxxb1;
            }).collect(Collectors.toList());
            ppxxbService.updateBatchByMultiId(collect);
        });
        return new ResultBean<>();
    }
}
