package com.dsic.gj_erp.service.pgd.impl;

import cn.hutool.core.date.DateUtil;
import com.dsic.gj_erp.bean.pgd.PgdDh;
import com.dsic.gj_erp.bean.pgd.PgdSljh;
import com.dsic.gj_erp.bean.pgd.PgdTzjh;
import com.dsic.gj_erp.mapper.pgd.PgdSljhMapper;
import com.dsic.gj_erp.service.pgd.PgdSljhService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@Service
public class PgdSljhServiceImpl extends ServiceImpl<PgdSljhMapper, PgdSljh> implements PgdSljhService {
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveSljhPgdXd(List<PgdSljh> sljhs, HttpServletRequest request) {

        List<PgdSljh>ups= new ArrayList<>();
        sljhs.forEach(f->{
            PgdSljh e= new PgdSljh();
            e.setXfry((String) request.getAttribute("yhms"));
            e.setXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("02");
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveSljhPgdFk(List<PgdSljh> sljhs, HttpServletRequest request) {

        List<PgdSljh>ups= new ArrayList<>();
        sljhs.forEach(f->{
            PgdSljh e= new PgdSljh();
            e.setFkry((String) request.getAttribute("yhms"));
            e.setFkrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("09");
            e.setFkyy(f.getFkyy());
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Override
    public void saveSljhFk(List<PgdSljh> sljhs, HttpServletRequest request) {
        List<PgdSljh>ups= new ArrayList<>();
        sljhs.forEach(f->{
            PgdSljh e= new PgdSljh();
            e.setSlry(f.getSlry());
            e.setSlksrq(f.getSlksrq());
            e.setSjjsrq(f.getSjjsrq());
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveSljhPgdXdBack(List<PgdSljh> sljhs, HttpServletRequest request) {

        List<PgdSljh>ups= new ArrayList<>();
        sljhs.forEach(f->{
            PgdSljh e= new PgdSljh();
            e.setXfry((String) request.getAttribute("yhms"));
            e.setXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            if(f.getZt().equals("02")){
                e.setZt("01");
            }
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }
}
